// Code generated by MockGen. DO NOT EDIT.
// Source: gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v17/internal/module/agent_tracker (interfaces: Tracker)
//
// Generated by this command:
//
//	mockgen -typed -destination tracker.go gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v17/internal/module/agent_tracker Tracker
//

// Package mock_agent_tracker is a generated GoMock package.
package mock_agent_tracker

import (
	context "context"
	reflect "reflect"

	agent_tracker "gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v17/internal/module/agent_tracker"
	gomock "go.uber.org/mock/gomock"
)

// MockTracker is a mock of Tracker interface.
type MockTracker struct {
	ctrl     *gomock.Controller
	recorder *MockTrackerMockRecorder
}

// MockTrackerMockRecorder is the mock recorder for MockTracker.
type MockTrackerMockRecorder struct {
	mock *MockTracker
}

// NewMockTracker creates a new mock instance.
func NewMockTracker(ctrl *gomock.Controller) *MockTracker {
	mock := &MockTracker{ctrl: ctrl}
	mock.recorder = &MockTrackerMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockTracker) EXPECT() *MockTrackerMockRecorder {
	return m.recorder
}

// CountAgentsByAgentVersions mocks base method.
func (m *MockTracker) CountAgentsByAgentVersions(arg0 context.Context) (map[string]int64, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "CountAgentsByAgentVersions", arg0)
	ret0, _ := ret[0].(map[string]int64)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// CountAgentsByAgentVersions indicates an expected call of CountAgentsByAgentVersions.
func (mr *MockTrackerMockRecorder) CountAgentsByAgentVersions(arg0 any) *MockTrackerCountAgentsByAgentVersionsCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "CountAgentsByAgentVersions", reflect.TypeOf((*MockTracker)(nil).CountAgentsByAgentVersions), arg0)
	return &MockTrackerCountAgentsByAgentVersionsCall{Call: call}
}

// MockTrackerCountAgentsByAgentVersionsCall wrap *gomock.Call
type MockTrackerCountAgentsByAgentVersionsCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockTrackerCountAgentsByAgentVersionsCall) Return(arg0 map[string]int64, arg1 error) *MockTrackerCountAgentsByAgentVersionsCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockTrackerCountAgentsByAgentVersionsCall) Do(f func(context.Context) (map[string]int64, error)) *MockTrackerCountAgentsByAgentVersionsCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockTrackerCountAgentsByAgentVersionsCall) DoAndReturn(f func(context.Context) (map[string]int64, error)) *MockTrackerCountAgentsByAgentVersionsCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// GetConnectedAgentsCount mocks base method.
func (m *MockTracker) GetConnectedAgentsCount(arg0 context.Context) (int64, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetConnectedAgentsCount", arg0)
	ret0, _ := ret[0].(int64)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetConnectedAgentsCount indicates an expected call of GetConnectedAgentsCount.
func (mr *MockTrackerMockRecorder) GetConnectedAgentsCount(arg0 any) *MockTrackerGetConnectedAgentsCountCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetConnectedAgentsCount", reflect.TypeOf((*MockTracker)(nil).GetConnectedAgentsCount), arg0)
	return &MockTrackerGetConnectedAgentsCountCall{Call: call}
}

// MockTrackerGetConnectedAgentsCountCall wrap *gomock.Call
type MockTrackerGetConnectedAgentsCountCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockTrackerGetConnectedAgentsCountCall) Return(arg0 int64, arg1 error) *MockTrackerGetConnectedAgentsCountCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockTrackerGetConnectedAgentsCountCall) Do(f func(context.Context) (int64, error)) *MockTrackerGetConnectedAgentsCountCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockTrackerGetConnectedAgentsCountCall) DoAndReturn(f func(context.Context) (int64, error)) *MockTrackerGetConnectedAgentsCountCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// GetConnectionsByAgentID mocks base method.
func (m *MockTracker) GetConnectionsByAgentID(arg0 context.Context, arg1 int64, arg2 agent_tracker.ConnectedAgentInfoCallback) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetConnectionsByAgentID", arg0, arg1, arg2)
	ret0, _ := ret[0].(error)
	return ret0
}

// GetConnectionsByAgentID indicates an expected call of GetConnectionsByAgentID.
func (mr *MockTrackerMockRecorder) GetConnectionsByAgentID(arg0, arg1, arg2 any) *MockTrackerGetConnectionsByAgentIDCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetConnectionsByAgentID", reflect.TypeOf((*MockTracker)(nil).GetConnectionsByAgentID), arg0, arg1, arg2)
	return &MockTrackerGetConnectionsByAgentIDCall{Call: call}
}

// MockTrackerGetConnectionsByAgentIDCall wrap *gomock.Call
type MockTrackerGetConnectionsByAgentIDCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockTrackerGetConnectionsByAgentIDCall) Return(arg0 error) *MockTrackerGetConnectionsByAgentIDCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockTrackerGetConnectionsByAgentIDCall) Do(f func(context.Context, int64, agent_tracker.ConnectedAgentInfoCallback) error) *MockTrackerGetConnectionsByAgentIDCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockTrackerGetConnectionsByAgentIDCall) DoAndReturn(f func(context.Context, int64, agent_tracker.ConnectedAgentInfoCallback) error) *MockTrackerGetConnectionsByAgentIDCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// GetConnectionsByProjectID mocks base method.
func (m *MockTracker) GetConnectionsByProjectID(arg0 context.Context, arg1 int64, arg2 agent_tracker.ConnectedAgentInfoCallback) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetConnectionsByProjectID", arg0, arg1, arg2)
	ret0, _ := ret[0].(error)
	return ret0
}

// GetConnectionsByProjectID indicates an expected call of GetConnectionsByProjectID.
func (mr *MockTrackerMockRecorder) GetConnectionsByProjectID(arg0, arg1, arg2 any) *MockTrackerGetConnectionsByProjectIDCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetConnectionsByProjectID", reflect.TypeOf((*MockTracker)(nil).GetConnectionsByProjectID), arg0, arg1, arg2)
	return &MockTrackerGetConnectionsByProjectIDCall{Call: call}
}

// MockTrackerGetConnectionsByProjectIDCall wrap *gomock.Call
type MockTrackerGetConnectionsByProjectIDCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockTrackerGetConnectionsByProjectIDCall) Return(arg0 error) *MockTrackerGetConnectionsByProjectIDCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockTrackerGetConnectionsByProjectIDCall) Do(f func(context.Context, int64, agent_tracker.ConnectedAgentInfoCallback) error) *MockTrackerGetConnectionsByProjectIDCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockTrackerGetConnectionsByProjectIDCall) DoAndReturn(f func(context.Context, int64, agent_tracker.ConnectedAgentInfoCallback) error) *MockTrackerGetConnectionsByProjectIDCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// RegisterExpiring mocks base method.
func (m *MockTracker) RegisterExpiring(arg0 context.Context, arg1 *agent_tracker.ConnectedAgentInfo) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "RegisterExpiring", arg0, arg1)
	ret0, _ := ret[0].(error)
	return ret0
}

// RegisterExpiring indicates an expected call of RegisterExpiring.
func (mr *MockTrackerMockRecorder) RegisterExpiring(arg0, arg1 any) *MockTrackerRegisterExpiringCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "RegisterExpiring", reflect.TypeOf((*MockTracker)(nil).RegisterExpiring), arg0, arg1)
	return &MockTrackerRegisterExpiringCall{Call: call}
}

// MockTrackerRegisterExpiringCall wrap *gomock.Call
type MockTrackerRegisterExpiringCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockTrackerRegisterExpiringCall) Return(arg0 error) *MockTrackerRegisterExpiringCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockTrackerRegisterExpiringCall) Do(f func(context.Context, *agent_tracker.ConnectedAgentInfo) error) *MockTrackerRegisterExpiringCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockTrackerRegisterExpiringCall) DoAndReturn(f func(context.Context, *agent_tracker.ConnectedAgentInfo) error) *MockTrackerRegisterExpiringCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Run mocks base method.
func (m *MockTracker) Run(arg0 context.Context) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Run", arg0)
	ret0, _ := ret[0].(error)
	return ret0
}

// Run indicates an expected call of Run.
func (mr *MockTrackerMockRecorder) Run(arg0 any) *MockTrackerRunCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Run", reflect.TypeOf((*MockTracker)(nil).Run), arg0)
	return &MockTrackerRunCall{Call: call}
}

// MockTrackerRunCall wrap *gomock.Call
type MockTrackerRunCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockTrackerRunCall) Return(arg0 error) *MockTrackerRunCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockTrackerRunCall) Do(f func(context.Context) error) *MockTrackerRunCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockTrackerRunCall) DoAndReturn(f func(context.Context) error) *MockTrackerRunCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}
